
type SPECTRUMDATA ' SpectrumInitData, SpectrumWriteData, SpectrumWriteData
	' bitmap
	HDC       hdc
	HBITMAP   hbm
	SIZE      size
	' control
	HWND      hwndControl
	HDC       hdcControl
	HBRUSH    hbrBackground  ' background
	HPEN      hPenFFT ' ink color
	HPEN      hPenGrid
	HFONT     font
'	HANDLE    hThread
	POINT     cursor      ' SpectrumOnMouseMove(POINT)
	BOOL      fMouseDown  ' SpectrumSetMouseDown(BOOL)
	' samples
	int       nAvgBytesPerSec ' this is initialized but not yet used
	int       n  ' size of fft array; number of _complex structures
	pointer  fft ' _complex*
endtype

type SPECTRUMNODE
	pointer pNext
	int count
	double samples[0]
endtype

' loads FFTW library, allocates GDI handles
declare extern SpectrumInitialize(HWND hwndSpectrum, int nAvgBytesPerSec),BOOL
' allocates or resize FFT buffer
declare extern SpectrumInitData(int nSamples)
' frees all resources
declare extern SpectrumDestroyData()
' adds new audio samples to queue
declare extern SpectrumWriteData(pointer pdSample, int count)
' draws the spectogram
declare extern SpectrumPaint()
' erases the spectogram
declare extern SpectrumErase()
declare extern SpectrumOnMouseMove(POINT pt)
declare extern SpectrumSetMouseDown(BOOL down)
declare extern SpectrumIsInitialized(),BOOL

